#pragma once

#include <iostream>
#include <complex>
#include <vector>
#include <Eigen/Dense>
#include <gsl/gsl_sf_legendre.h>

extern std::vector<double> LegP1, LegP2;
extern std::complex<double> JJ;

class AI_IDS_ch4_n2 
{
public:
    void init();
    
    static constexpr size_t index(const int l, const int m) {
        return l * (l + 1) / 2 + m;
    }

    static void fill_legP1(const double theta1);
    static void fill_legP2(const double theta2); 

    static void ids_p1(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p2(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p3(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p4(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p5(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p6(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p7(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p8(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p9(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p10(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p11(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p12(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p13(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p14(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p15(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p16(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p17(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p18(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p19(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p20(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p21(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p22(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p23(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p24(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p25(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p26(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p27(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p28(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p29(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p30(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);
    static void ids_p31(Eigen::Ref<Eigen::Vector3cd> result, double R, double phi1, double theta1, double phi2, double theta2);

    static void ids(Eigen::Ref<Eigen::Vector3d> result, double R, double phi1, double theta1, double phi2, double theta2);
private:
    static std::vector<double> LegP1, LegP2;

    static const int lmax_bond = 13;
    static const int lmax_n2 = 12;

    static gsl_sf_legendre_t norm;
    static constexpr double csphase = -1; // to include Condon-Shortley phase
    
    static std::complex<double> JJ;
};
